# coding: utf-8

"""
    Marketing API v.1.0

    IMPORTANT: This swagger links to Criteo production environment. Any test applied here will thus impact real campaigns.  # noqa: E501

    The version of the OpenAPI document: v.1.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class ProductShippingV3(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'price': 'Price',
        'country': 'str',
        'region': 'str',
        'service': 'str',
        'location_id': 'object',
        'location_group_name': 'str',
        'postal_code': 'str'
    }

    attribute_map = {
        'price': 'price',
        'country': 'country',
        'region': 'region',
        'service': 'service',
        'location_id': 'locationId',
        'location_group_name': 'locationGroupName',
        'postal_code': 'postalCode'
    }

    def __init__(self, price=None, country=None, region=None, service=None, location_id=None, location_group_name=None, postal_code=None):  # noqa: E501
        """ProductShippingV3 - a model defined in OpenAPI"""  # noqa: E501

        self._price = None
        self._country = None
        self._region = None
        self._service = None
        self._location_id = None
        self._location_group_name = None
        self._postal_code = None
        self.discriminator = None

        if price is not None:
            self.price = price
        if country is not None:
            self.country = country
        if region is not None:
            self.region = region
        if service is not None:
            self.service = service
        if location_id is not None:
            self.location_id = location_id
        if location_group_name is not None:
            self.location_group_name = location_group_name
        if postal_code is not None:
            self.postal_code = postal_code

    @property
    def price(self):
        """Gets the price of this ProductShippingV3.  # noqa: E501


        :return: The price of this ProductShippingV3.  # noqa: E501
        :rtype: Price
        """
        return self._price

    @price.setter
    def price(self, price):
        """Sets the price of this ProductShippingV3.


        :param price: The price of this ProductShippingV3.  # noqa: E501
        :type: Price
        """

        self._price = price

    @property
    def country(self):
        """Gets the country of this ProductShippingV3.  # noqa: E501

        The CLDR territory code of the country to which an item will ship.  # noqa: E501

        :return: The country of this ProductShippingV3.  # noqa: E501
        :rtype: str
        """
        return self._country

    @country.setter
    def country(self, country):
        """Sets the country of this ProductShippingV3.

        The CLDR territory code of the country to which an item will ship.  # noqa: E501

        :param country: The country of this ProductShippingV3.  # noqa: E501
        :type: str
        """

        self._country = country

    @property
    def region(self):
        """Gets the region of this ProductShippingV3.  # noqa: E501

        The geographic region to which a shipping rate applies.  # noqa: E501

        :return: The region of this ProductShippingV3.  # noqa: E501
        :rtype: str
        """
        return self._region

    @region.setter
    def region(self, region):
        """Sets the region of this ProductShippingV3.

        The geographic region to which a shipping rate applies.  # noqa: E501

        :param region: The region of this ProductShippingV3.  # noqa: E501
        :type: str
        """

        self._region = region

    @property
    def service(self):
        """Gets the service of this ProductShippingV3.  # noqa: E501

        A free-form description of the service class or delivery speed.  # noqa: E501

        :return: The service of this ProductShippingV3.  # noqa: E501
        :rtype: str
        """
        return self._service

    @service.setter
    def service(self, service):
        """Sets the service of this ProductShippingV3.

        A free-form description of the service class or delivery speed.  # noqa: E501

        :param service: The service of this ProductShippingV3.  # noqa: E501
        :type: str
        """

        self._service = service

    @property
    def location_id(self):
        """Gets the location_id of this ProductShippingV3.  # noqa: E501

        The numeric ID of a location that the shipping rate applies to as defined in the AdWords API.  # noqa: E501

        :return: The location_id of this ProductShippingV3.  # noqa: E501
        :rtype: object
        """
        return self._location_id

    @location_id.setter
    def location_id(self, location_id):
        """Sets the location_id of this ProductShippingV3.

        The numeric ID of a location that the shipping rate applies to as defined in the AdWords API.  # noqa: E501

        :param location_id: The location_id of this ProductShippingV3.  # noqa: E501
        :type: object
        """

        self._location_id = location_id

    @property
    def location_group_name(self):
        """Gets the location_group_name of this ProductShippingV3.  # noqa: E501

        The location where the shipping is applicable, represented by a location group name.  # noqa: E501

        :return: The location_group_name of this ProductShippingV3.  # noqa: E501
        :rtype: str
        """
        return self._location_group_name

    @location_group_name.setter
    def location_group_name(self, location_group_name):
        """Sets the location_group_name of this ProductShippingV3.

        The location where the shipping is applicable, represented by a location group name.  # noqa: E501

        :param location_group_name: The location_group_name of this ProductShippingV3.  # noqa: E501
        :type: str
        """

        self._location_group_name = location_group_name

    @property
    def postal_code(self):
        """Gets the postal_code of this ProductShippingV3.  # noqa: E501

        The postal code range that the shipping rate applies to, represented by a postal code, a postal code prefix followed by a * wildcard, a range between two postal codes or two postal code prefixes of equal length.  # noqa: E501

        :return: The postal_code of this ProductShippingV3.  # noqa: E501
        :rtype: str
        """
        return self._postal_code

    @postal_code.setter
    def postal_code(self, postal_code):
        """Sets the postal_code of this ProductShippingV3.

        The postal code range that the shipping rate applies to, represented by a postal code, a postal code prefix followed by a * wildcard, a range between two postal codes or two postal code prefixes of equal length.  # noqa: E501

        :param postal_code: The postal_code of this ProductShippingV3.  # noqa: E501
        :type: str
        """

        self._postal_code = postal_code

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ProductShippingV3):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
