# coding: utf-8

"""
    Marketing API v.1.0

    IMPORTANT: This swagger links to Criteo production environment. Any test applied here will thus impact real campaigns.  # noqa: E501

    The version of the OpenAPI document: v.1.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class ProductTaxV3(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'rate': 'float',
        'country': 'str',
        'region': 'str',
        'tax_ship': 'bool',
        'location_id': 'object',
        'postal_code': 'str'
    }

    attribute_map = {
        'rate': 'rate',
        'country': 'country',
        'region': 'region',
        'tax_ship': 'taxShip',
        'location_id': 'locationId',
        'postal_code': 'postalCode'
    }

    def __init__(self, rate=None, country=None, region=None, tax_ship=None, location_id=None, postal_code=None):  # noqa: E501
        """ProductTaxV3 - a model defined in OpenAPI"""  # noqa: E501

        self._rate = None
        self._country = None
        self._region = None
        self._tax_ship = None
        self._location_id = None
        self._postal_code = None
        self.discriminator = None

        if rate is not None:
            self.rate = rate
        if country is not None:
            self.country = country
        if region is not None:
            self.region = region
        if tax_ship is not None:
            self.tax_ship = tax_ship
        if location_id is not None:
            self.location_id = location_id
        if postal_code is not None:
            self.postal_code = postal_code

    @property
    def rate(self):
        """Gets the rate of this ProductTaxV3.  # noqa: E501

        The percentage of tax rate that applies to the item price.  # noqa: E501

        :return: The rate of this ProductTaxV3.  # noqa: E501
        :rtype: float
        """
        return self._rate

    @rate.setter
    def rate(self, rate):
        """Sets the rate of this ProductTaxV3.

        The percentage of tax rate that applies to the item price.  # noqa: E501

        :param rate: The rate of this ProductTaxV3.  # noqa: E501
        :type: float
        """

        self._rate = rate

    @property
    def country(self):
        """Gets the country of this ProductTaxV3.  # noqa: E501

        The country within which the item is taxed, specified as a CLDR territory code.  # noqa: E501

        :return: The country of this ProductTaxV3.  # noqa: E501
        :rtype: str
        """
        return self._country

    @country.setter
    def country(self, country):
        """Sets the country of this ProductTaxV3.

        The country within which the item is taxed, specified as a CLDR territory code.  # noqa: E501

        :param country: The country of this ProductTaxV3.  # noqa: E501
        :type: str
        """

        self._country = country

    @property
    def region(self):
        """Gets the region of this ProductTaxV3.  # noqa: E501

        The geographic region to which the tax rate applies.  # noqa: E501

        :return: The region of this ProductTaxV3.  # noqa: E501
        :rtype: str
        """
        return self._region

    @region.setter
    def region(self, region):
        """Sets the region of this ProductTaxV3.

        The geographic region to which the tax rate applies.  # noqa: E501

        :param region: The region of this ProductTaxV3.  # noqa: E501
        :type: str
        """

        self._region = region

    @property
    def tax_ship(self):
        """Gets the tax_ship of this ProductTaxV3.  # noqa: E501

        Set to true if tax is charged on shipping.  # noqa: E501

        :return: The tax_ship of this ProductTaxV3.  # noqa: E501
        :rtype: bool
        """
        return self._tax_ship

    @tax_ship.setter
    def tax_ship(self, tax_ship):
        """Sets the tax_ship of this ProductTaxV3.

        Set to true if tax is charged on shipping.  # noqa: E501

        :param tax_ship: The tax_ship of this ProductTaxV3.  # noqa: E501
        :type: bool
        """

        self._tax_ship = tax_ship

    @property
    def location_id(self):
        """Gets the location_id of this ProductTaxV3.  # noqa: E501

        The numeric ID of a location that the tax rate applies to as defined in the AdWords API.  # noqa: E501

        :return: The location_id of this ProductTaxV3.  # noqa: E501
        :rtype: object
        """
        return self._location_id

    @location_id.setter
    def location_id(self, location_id):
        """Sets the location_id of this ProductTaxV3.

        The numeric ID of a location that the tax rate applies to as defined in the AdWords API.  # noqa: E501

        :param location_id: The location_id of this ProductTaxV3.  # noqa: E501
        :type: object
        """

        self._location_id = location_id

    @property
    def postal_code(self):
        """Gets the postal_code of this ProductTaxV3.  # noqa: E501

        The postal code range that the tax rate applies to, represented by a ZIP code, a ZIP code prefix using * wildcard, a range between two ZIP codes or two ZIP code prefixes of equal length. Examples: 94114, 94*, 94002-95460, 94*-95*.  # noqa: E501

        :return: The postal_code of this ProductTaxV3.  # noqa: E501
        :rtype: str
        """
        return self._postal_code

    @postal_code.setter
    def postal_code(self, postal_code):
        """Sets the postal_code of this ProductTaxV3.

        The postal code range that the tax rate applies to, represented by a ZIP code, a ZIP code prefix using * wildcard, a range between two ZIP codes or two ZIP code prefixes of equal length. Examples: 94114, 94*, 94002-95460, 94*-95*.  # noqa: E501

        :param postal_code: The postal_code of this ProductTaxV3.  # noqa: E501
        :type: str
        """

        self._postal_code = postal_code

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ProductTaxV3):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
